program BC;


DEVICE = mega1284P;



CONST

  // BAUDRATE  = 38400;
  // ProcClock = 16384000;       {Hertz}
  // ((ProcClock+BAUDRATE*8)/(BAUDRATE*16)-1)
  // (((38400*8)+16384000)/(38400*16))-1) = ((307200+16384000)/614400)-1 =
  // (16998400/614400)-1 = 27-1 = 26
  UBRR_VAL : WORD = 26;

  XON  : Byte = $11;
  XOFF : Byte = $13;

  // Befehlscode fuer den Adress Extender
  kein_Code       : Byte = 00;
  LOAD_ADRESS     : Byte = 01;   // laden einer neuen Adresse
  INC_ADRESS      : Byte = 02;   // Inkrement der geladenen Adresse
  ADRESS_TRISTATE : Byte = 03;   // Adressbus auf Treestate setzen
  WAIT_Z80ToBuf   : Byte = 04;   // Wait Z80-Bus to AE-Buffer
  WAIT_BufToBC    : Byte = 05;   // Wait AE-Buffer to Bus-Controller


  // Befehlscode fuer Z80CALL
  BC_CONIN        : Byte = 01;
  BC_CONST        : Byte = 02;
  BC_CONOUT       : Byte = 03;





{--------------------------------------------------------------}


var

{
UDR1, UBRR1H, UBRR1L, UCSR1C, UCSR1B, UCSR1A
UDR0, UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A
TWAM, TWCR, TWDR, TWAR, TWSR, TWBR, 
ASSR, OCR2B, OCR2A, OCR2, 
TCNT2, TCCR2, TCCR2B, TCCR2A,
OCR1BH, OCR1BL, OCR1AH, OCR1AL,
ICR1H, ICR1L, 
TCNT1H, TCNT1L, TCCR1C, TCCR1B, TCCR1A
DIDR1, DIDR0,
ADMUX, ADCSRB, ADCSR, ADCSRA, ADCH, ADCL
PCMSK3, 
TIMSK2, TIMSK1, TIMSK0,
PCMSK2, PCMSK1, PCMSK0,
EICRA, PCICR, OSCCAL,
PRR, PRR0,
CLKPR, WDTCR, WDTCSR,
SREG, SPH, SPL, RAMPZ,
SPMCSR, SPMCR, MCUCR, MCUCSR, MCUSR, SMCR,
OCDR, ACSR, SPDR, SPDR0, SPSR, SPSR0, SPCR, SPCR0,
GPIOR2, GPIOR1, 
OCR0B, OCR0, OCR0A,
TCNT0, TCCR0B, TCCR0, TCCR0A,
GTCCR, 
EEARH, EEARL, EEDR, EECR,
GPIOR0,
EIMSK, EIFR, PCIFR,
TIFR2, TIFR1, TIFR0,
}

  PORTD, DDRD, PIND, PORTC, DDRC, PINC, 
  PORTB, DDRB, PINB, PORTA, DDRA, PINA : ByteConReg; 

  UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A, UDR0 : ByteConVar;
  UBRR0 : WordConVar;


  RXC0[UCSR0A,7]  : Bit;
  TXC0[UCSR0A,6]  : Bit;
  UDRE0[UCSR0A,5] : Bit;



{
PB0 = frei
PB1 = /AECMD   A -> H / AE Command / Work in Mode
PB2 = /BCWCLR  A -> H / BC Wait Clear (Aktiv bei L)
PB3 = BCWA     A -> L / BC Wait (Aktiv bei H)
PB4 = /Z80WA   E -> H / Z80 Wait(Aktiv bei L)
}

  Taste_E[PINB,0]   : bit;
  AECMD_A[PortB,1]  : bit;
  BCWCLR_A[PortB,2] : bit;
  BCWA_A  [PortB,3] : bit;
  Z80WA_E [PINB, 4] : bit;


{
PC0 = /WAIT    E -> X
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}

  WAIT_E [PINC, 0] : bit;

  MREQ_A [PortC,1] : bit;
  MREQ_E [PINC, 1] : bit;
  MREQ_D [DDRC, 1] : bit;

  IORQ_A [PortC,2] : bit;
  IORQ_E [PINC, 2] : bit;
  IORQ_D [DDRC, 2] : bit;

  RD_A   [PortC,3] : bit;
  RD_E   [PINC, 3] : bit;
  RD_D   [DDRC, 3] : bit;

  WR_A   [PortC,4] : bit;
  WR_E   [PINC, 4] : bit;
  WR_D   [DDRC, 4] : bit;

  RESET_A[PortC,5] : bit;

  BUSRQ_A[PortC,6] : bit;

  BUSAK_E[PINC, 7] : bit;

{
PD0 = RXD0      E <-
PD1 = TXD0      A ->
PD2 = /AECS     A -> H
PD3 = /AERQ     E <- X
PD4 = /Z80CALL  E <- X
PD5 = /Z80AK    A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}

  AECS_A [PortD,2]  : bit;
  AERQ_E [PIND,3]   : bit;
  Z80CALL_E[PIND,4] : bit;
  Z80AK_A[PortD,5]  : bit;
  LED_GRUEN[PortD,6]: bit;
  LED_ROT[PortD,7]  : bit;






  Zeichen : Byte;

  loop_in, BIOS_geladen : Boolean;


  RAM_Zelle : Byte;

  ConsoleIn : Byte;

  Write_String : String[20];
  Steuer_String : String[20];


CONST

  Laenge_Array : Word = 255;

  Loader : array[0..255] of Byte = (

 $F3,$31,$80,$FE,$21,$12,$00,$11,$00,$F0,$01,$79,$00,$ED,$B0,$C3,	// 0000H
 $00,$F0,$CD,$49,$F0,$3E,$07,$32,$84,$FE,$06,$01,$0E,$00,$16,$00,	// 0010H
 $CD,$1F,$F0,$FE,$00,$28,$F3,$06,$03,$4F,$16,$00,$CD,$1F,$F0,$18,	// 0020H
 $E9,$DB,$F8,$CB,$4F,$28,$FA,$78,$32,$80,$FE,$79,$32,$81,$FE,$7A,	// 0030H
 $32,$82,$FE,$3A,$84,$FE,$CB,$87,$D3,$F8,$DB,$F8,$CB,$4F,$20,$FA,	// 0040H
 $3A,$84,$FE,$CB,$C7,$D3,$F8,$3A,$81,$FE,$C9,$21,$55,$F0,$06,$12,	// 0050H
 $4E,$23,$ED,$A3,$20,$FA,$C9,$F9,$03,$FB,$03,$F8,$07,$F9,$CF,$F9,	// 0060H
 $F2,$F8,$07,$FA,$30,$FB,$CF,$FB,$EF,$FA,$30,$F4,$30,$F5,$CF,$F5,	// 0070H
 $EF,$F4,$30,$F6,$30,$F7,$CF,$F7,$EF,$F6,$30,$00,$00,$00,$00,$00,	// 0080H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 0090H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 00A0H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 00B0H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 00C0H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 00D0H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 00E0H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

);


RAM_Z80_High   : Byte = $FE;
RAM_Z80CALL_MD : Byte = $80;
RAM_Z80CALL_P1 : Byte = $81;
RAM_Z80CALL_P2 : Byte = $82;



{--------------------------------------------------------------}
{ functions }


procedure InitPorts;
begin
  // PORT A = Daten
  DDRA:=  %00000000;


{
PB0 = Taste    E -> L 

PB1 = /AECMD   A -> H / AE Command / Work in Mode
PB2 = /BCWCLR  A -> H / BC Wait Clear (Aktiv bei L)
PB3 = BCWA     A -> L / BC Wait (Aktiv bei H)
PB4 = /Z80WA   E -> H / Z80 Wait(Aktiv bei L)

PB5 = MOSI 
PB6 = MISO 
PB7 = SCK 
}
  // PORT B Voreinstellungen
  PORTB:= %00000111;

  //       EEEEAAEE
  DDRB:=  %00001110;

  // PORT B Voreinstellungen
  PORTB:= %00000111;

{
PC0 = /WAIT    E -> X
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  PORTC:= %00111110;

  //       EAAAAAAE
  DDRC:=  %01111110;

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  PORTC:= %00111110;

{
PD0 = RXD0      E <-
PD1 = TXD0      A ->
PD2 = /AECS     A -> H
PD3 = /AERQ     E <- X
PD4 = /Z80CALL  E <- X
PD5 = /Z80AK    A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}
  // PORT D Voreinstellungen
  PORTD:= %00100100;

  //       AAAEEAAE
  DDRD:=  %11100110;

  // PORT D Voreinstellungen
  PORTD:= %00100100;

end InitPorts;




// ******************************
// ***    Hilfssprogramme     ***
// ******************************




PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 720 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;








// ******************************
// *** serielle Schnittstelle ***
// ******************************



procedure INIT_SER_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0 := UBRR_VAL;

{
Bit 4 – RXEN: Receiver Enable
Bit 3 – TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER_PORT;





procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
  else
    Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;





procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0  
  while BitLow(UDRE0) do
    SetBit(LED_GRUEN); // gruen ein
  endwhile;

  ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen; 



procedure sende_HEX_Zeichen(h_Zeichen : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
begin

  HexHigh:=h_Zeichen and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  sende_Zeichen(HexHigh); 

  HexLow:=h_Zeichen and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  sende_Zeichen(HexLow);

  sende_Zeichen($48); // H

end sende_HEX_Zeichen;



procedure sende_HEX_Zeichen_Ln(Wert_Byte : Byte);
begin
  sende_HEX_Zeichen(Wert_Byte);
  sende_Zeichen($0D); // CR
  sende_Zeichen($0A); // LF
end sende_HEX_Zeichen_Ln;



procedure Write;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen(b2);
  endfor;

end Write;




procedure WriteLn;
begin
  Write;
  sende_Zeichen($0D); // CR
  sende_Zeichen($0A); // LF
end WriteLn;





procedure ByteToString(Wert_Byte : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
  c1 : Char;
begin

  HexHigh:=Wert_Byte and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  c1:=ByteToChar(HexHigh);
  Write_String:=c1;

  HexLow:=Wert_Byte and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  c1:=ByteToChar(HexLow);
  Write_String:=Write_String+c1;

end ByteToString;







function StringToByte : Byte;
var
  HexLow : Byte;
  HexHigh : Byte;
  S2B : Byte;
  c1 : Char;
begin

  c1:=Write_String[1];
  HexHigh:=CharToByte(c1);
  HexHigh:=HexHigh-48;
  if HexHigh>9 then
    HexHigh:=HexHigh-7;
  endif;
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);

  c1:=Write_String[2];
  HexLow:=CharToByte(c1);
  HexLow:=HexLow-48;
  if HexLow>9 then
    HexLow:=HexLow-7;
  endif;

  S2B:=HexHigh+HexLow;

  RESULT:=S2B;

end StringToByte;





// ******************************
// ***   AE-Hilfsprogramme    ***
// ******************************





// ein Byte an AE senden
procedure AE_WRITE_BYTE(WR_Byte : byte);
begin

  // warten bis ATMEGA162 bereit ist
  while BitLow(AERQ_E) do
  endwhile;

  // /AECMD aktiv schalten
  ClearBit(AECMD_A);   

  // Datenbus auf Ausgang
  DDRA:= %11111111; // D0-D7 A

  // Daten auf Datenbus legen
  PORTA:=WR_Byte;

  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

  // AECS_A aktiv schalten (Daten koennen uebernommen werden)
  ClearBit(AECS_A);

  // warten bis Daten uebernommen wurden
  while BitHigh(AERQ_E) do
  endwhile;

  // Betriebsart Programmieren abschalten
  SetBit(AECS_A);  // AECS_A inaktiv

  // Uebertragung abgeschlossen

  DDRA:= %00000000; // Datenbus auf Eingang
  
  SetBit(AECMD_A);    // AECMD_A inaktiv

end AE_WRITE_BYTE; 






procedure AE_WRITE_ADRESS(a16, a08, a00 : byte);
begin

  AE_WRITE_BYTE(LOAD_ADRESS);

  // adr_00_07
  AE_WRITE_BYTE(a00);

  // adr_08_15
  AE_WRITE_BYTE(a08);

  // adr_16_18
  AE_WRITE_BYTE(a16);

end AE_WRITE_ADRESS;



// ******************************
// ***   RAM-Hilfsprogramme   ***
// ******************************



procedure COPY_ARRAY_TO_RAM;
var
  READ_DATA : Byte;
  Adresse : Word;
begin


  AE_WRITE_ADRESS(0,0,0);

  // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(MREQ_A);
  SetBit(AECS_A);
  SetBit(AECMD_A);

  Adresse:=0;

  loop_in := false;

  AE_WRITE_BYTE(INC_ADRESS);

  DDRA := %11111111; // Daten alles Ausgänge
   
  for Adresse:=0 to Laenge_Array do

    if loop_in then
      // warten falls Adress-Decoder noch beschaeftigt ist (unwahrscheinlich)
      while BitHigh(AERQ_E) do
      endwhile;
    else
      loop_in := true;
    endif;

    // jetzt Adressdecoder inaktivieren
    SetBit(AECS_A);

    // Daten lesen von ARRAY
    READ_DATA:=Loader[Adresse];


    // Daten schreiben in RAM
    PortA := READ_DATA; // Data

    ClearBit(MREQ_A);
    ClearBit(WR_A); 

    NOP; // 6 x 64us
    NOP;  
    NOP; 
    NOP;  
    NOP; 
    NOP; 

    SetBit(MREQ_A);
    SetBit(WR_A);
 
    
    // naechste Adresse anlegen durch Adress-Decoder
    while BitLow(AERQ_E) do
    endwhile;

    ClearBit(AECS_A);  // AECS_A aktiv
   
  endfor; 

  DDRA :=  %00000000; // alles Eingänge


  // warten falls Adress-Decoder noch beschaeftigt ist (unwahrscheinlich)
  while BitHigh(AERQ_E) do
  endwhile;

  // jetzt AdressExtender inaktivieren
  SetBit(AECS_A);  // AECS_A inaktiv
  SetBit(WR_A);    // WE_A inaktiv
  SetBit(RD_A);    // OE_A inaktiv

  // warten bis Adress-Decoder bereit ist
  while BitLow(AERQ_E) do
  endwhile;


end COPY_ARRAY_TO_RAM;






procedure lese_RAM_Zelle;
begin

  DDRA :=  %00000000; // alles Eingänge

 // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(AECS_A);
  SetBit(AECMD_A);    // AECMD_A inaktiv

  // naechste Adresse anlegen durch Adress-Decoder
  while BitLow(AERQ_E) do
  endwhile;

  ClearBit(MREQ_A);
  ClearBit(RD_A);  

  NOP; 
  NOP;  
  NOP; 
  NOP;  
  NOP; 
  NOP;

  RAM_Zelle:=PINA;

  SetBit(RD_A);
  SetBit(MREQ_A);

end lese_RAM_Zelle;







procedure lese_RAM_Zelle_INC;
begin

  DDRA :=  %00000000; // alles Eingänge

 // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(AECS_A);
  SetBit(AECMD_A);    // AECMD_A inaktiv

  // naechste Adresse anlegen durch Adress-Decoder
  while BitLow(AERQ_E) do
  endwhile;

  ClearBit(MREQ_A);
  ClearBit(RD_A);

  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

  RAM_Zelle:=PINA;

  SetBit(RD_A);
  SetBit(MREQ_A);

  ClearBit(AECS_A);  // AECS_A aktiv

  // naechste Adresse anlegen durch Adress-Decoder
  while BitHigh(AERQ_E) do
  endwhile;

  SetBit(AECS_A);  // AECS_A inaktiv

end lese_RAM_Zelle_INC;










procedure schreibe_RAM_Zelle(Wert_Zelle : Byte);
begin

  // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(MREQ_A);
  SetBit(AECS_A);
  SetBit(AECMD_A);

  DDRA :=  %11111111; // alles Ausgaenge

  // naechste Adresse anlegen durch Adress-Decoder
  while BitLow(AERQ_E) do
  endwhile;

  // Daten schreiben in RAM
  PortA := Wert_Zelle; // Data

  ClearBit(MREQ_A);
  ClearBit(WR_A);

  NOP; // 6 x 64us
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

  SetBit(MREQ_A);
  SetBit(WR_A);

  DDRA :=  %00000000; // alles Eingänge

end schreibe_RAM_Zelle;









procedure schreibe_RAM_Zelle_INC(Wert_Zelle : Byte);
begin

  // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(MREQ_A);
  SetBit(AECS_A);
  SetBit(AECMD_A);

  DDRA :=  %11111111; // alles Ausgaenge

  // naechste Adresse anlegen durch Adress-Decoder
  while BitLow(AERQ_E) do
  endwhile;

  // Daten schreiben in RAM
  PortA := Wert_Zelle; // Data

  ClearBit(MREQ_A);
  ClearBit(WR_A);

  NOP; // 6 x 64us
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

  SetBit(MREQ_A);
  SetBit(WR_A);

  ClearBit(AECS_A);  // AECS_A aktiv

  DDRA :=  %00000000; // alles Eingänge

  // naechste Adresse anlegen durch Adress-Decoder
  while BitHigh(AERQ_E) do
  endwhile;

  SetBit(AECS_A);  // AECS_A inaktiv


end schreibe_RAM_Zelle_INC;








// ******************************
// ***   BUS-Hilfsprogramme   ***
// ******************************





procedure BC_Bus_anfordern;
begin

  // Busanforderung an Z80
  SetBit(LED_ROT);
  ClearBit(BUSRQ_A);

  while BitHigh(BUSAK_E) do
  endwhile;

  NOP; 
  NOP;
  NOP; 
  NOP;
 
  {
  PC0 = frei     E -> X
  PC1 = /MREQ    A -> H
  PC2 = /IORQ    A -> H
  PC3 = /RD      A -> H
  PC4 = /WR      A -> H
  PC5 = /RESET   A -> H
  PC6 = /BUSRQ   A -> H
  PC7 = /BUSAK   E <- X
  }

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  SetBit(MREQ_A);
  SetBit(IORQ_A);
  SetBit(RD_A);
  SetBit(WR_A);


  // PORT C Steuerleitungen als Ausgang schalten
  SetBit(MREQ_D);
  SetBit(IORQ_D);
  SetBit(RD_D);
  SetBit(WR_D);


  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  SetBit(MREQ_A);
  SetBit(IORQ_A);
  SetBit(RD_A);
  SetBit(WR_A);

 

  ClearBit(LED_ROT);

end BC_Bus_anfordern;




procedure BC_Bus_freigeben;
begin

  SetBit(LED_ROT);

  // PORT A = Daten
  DDRA:=  %00000000;

  // PORT B bleibt so

  {
  PC0 = frei     E -> X
  PC1 = /MREQ    A -> H
  PC2 = /IORQ    A -> H
  PC3 = /RD      A -> H
  PC4 = /WR      A -> H
  PC5 = /RESET   A -> H
  PC6 = /BUSRQ   A -> H
  PC7 = /BUSAK   E <- X
  }
  // PORT C Voreinstellungen (BUSRQ ist aktiv), Reset bleibt Ausgang
  // alle anderen Z80-Steuerleitungen werden
  // auf Eingang gestellt und freigegeben

  ClearBit(MREQ_D);
  ClearBit(IORQ_D);
  ClearBit(RD_D);
  ClearBit(WR_D);

  // PORT D bleibt so

  NOP; 
  NOP;
  NOP; 
  NOP;
 
  // jetzt wird die Z80 frei gegeben
  SetBit(BUSRQ_A);

  // warten bis Z80 den Bus uebernommen hat
  while BitLow(BUSAK_E) do
  endwhile;

  ClearBit(LED_ROT);

end BC_Bus_freigeben;






procedure starte_Z80;
begin

  // der Adress Extender gibt die Adressleitungen frei
  AE_WRITE_BYTE(ADRESS_TRISTATE);

  // als Erstes ziehen wir uns schrittweise zurueck
  BC_Bus_freigeben;

  // zur Bestaetigung wird die gruene LED eingeschaltet
  SetBit(LED_GRUEN);

  // fuer einen definierten Zustand wird
  // die Z80 noch einmal zurück gesetzt

  ClearBit(RESET_A);
  NOP;
  NOP;		// 20 Takte BC sind bei 4 MHz etwa 7 Takte Z80
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(RESET_A);


end starte_Z80;






procedure lese_WAIT_Buffer;
var
  Wert_Byte : Byte;
begin
  // warten bis ATMEGA162 bereit ist
  while BitLow(AERQ_E) do
  endwhile;

  // /AECMD inaktiv schalten
  SetBit(AECMD_A);

  // AECS_A aktiv schalten (Buszustand wird in AE gelesen)
  ClearBit(AECS_A);

  // warten bis AE fertig ist
  while BitHigh(AERQ_E) do
  endwhile;

  NOP;
  NOP;
  NOP;
  NOP;

  Wert_Byte := PinA;

  SetBit(AECS_A);  // AECS_A inaktiv

  ByteToString(Wert_Byte);

end lese_WAIT_Buffer;





procedure starte_WAIT;
var
  Wait_Zaehler : Word;
begin

  // Initialisieren des AE
  BC_Bus_anfordern;

  // der Adress Extender wird fuer das Einlesen initialisiert
  AE_WRITE_BYTE(WAIT_Z80ToBuf);

  BC_Bus_freigeben;

  // WAIT-Logik einschalten
  SetBit(BCWA_A);

  for Wait_Zaehler:=1 to 100 do

    // warten bis der M1-Zyklus der Z80 die Wait-Logik aktiviert
    // hat und /WAIT auf Low setzt
    while BitHigh(WAIT_E) do
    endwhile;

    wait_ms(1);

    // /AECMD inaktiv schalten
    SetBit(AECMD_A);

    // AECS_A aktiv schalten (Buszustand wird in AE gelesen)
    ClearBit(AECS_A);

    // warten bis AE fertig ist
    while BitHigh(AERQ_E) do
    endwhile;

    // AECS_A inaktiv schalten
    SetBit(AECS_A);  // AECS_A inaktiv

    // warten bis ATMEGA162 bereit ist
    while BitLow(AERQ_E) do
    endwhile;

   // Setzen der Wait-Logik
    ClearBit(BCWCLR_A);  // Low aktiv
    NOP;
    SetBit(BCWCLR_A);  // Low aktiv

  endfor; { for Wait_Zaehler:=1 to 100 do }


  // Abschalten der WAIT-Logik
  ClearBit(BCWA_A);

  BC_Bus_anfordern;

  // Initialisieren de AE
  AE_WRITE_BYTE(WAIT_BufToBC);

  // PORT A = Daten Eingang
  DDRA:=  %00000000;

  Write_String:='';

  for Wait_Zaehler:=1 to 100 do
    lese_WAIT_Buffer;
    lese_WAIT_Buffer;
    Write_String:=Write_String+',';
    lese_WAIT_Buffer;
    WriteLn;
    Write_String:='';
  endfor; { for Wait_Zaehler:=1 to 100 do }


  // der Adress Extender gibt die Adressleitungen frei
  AE_WRITE_BYTE(ADRESS_TRISTATE);

  BC_Bus_freigeben;


end starte_WAIT;














// ****************************************




procedure Steuer_String_auswerten;
var
  Buchstabe : Char;
  Zeichen_1 : Char;
  Zeichen_2 : Char;
  Laenge : Byte;
begin
  Laenge:=Length(Steuer_String);

  if Laenge>0 then
    Buchstabe:=Steuer_String[1];
    case Buchstabe of

      'T' : if Laenge=3 then
              Zeichen_1:=Steuer_String[2];
              Zeichen_2:=Steuer_String[3];
              Write_String:=Zeichen_1+Zeichen_2;
              ConsoleIn:=StringToByte;
            else
              SetBit(LED_ROT);
            endif;
      |


  else
    SetBit(LED_ROT);
  endcase;

  endif; { if Laenge>0 then }

end Steuer_String_auswerten;








procedure Steuer_String_lesen;
var
  akt_Zeichen : Char;
begin
  if Zeichen<>$0D then // 0D wird ignoriert

    if Zeichen=$0A then  // bei 0A wird ausgerwertet
      Steuer_String_auswerten;
      Steuer_String:='';
    else
      akt_Zeichen:=ByteToChar(Zeichen);
      Steuer_String:= Steuer_String + akt_Zeichen; // sonst nur abgespeichert
    endif; { if akt_Zeichen<>char($0A) }

  endif; { if akt_Zeichen<>char($0D) then }

end Steuer_String_lesen;





// ************************************











procedure Z80CALL_abfragen;
var
  b1 : Byte;
  c1 : Char;
begin

  if BitLow(Z80CALL_E) then

    ClearBit(LED_GRUEN);

    BC_Bus_anfordern;

   AE_WRITE_ADRESS(0,RAM_Z80_High,RAM_Z80CALL_MD);
   lese_RAM_Zelle;

   case RAM_Zelle of

     BC_CONOUT : AE_WRITE_ADRESS(0,RAM_Z80_High,RAM_Z80CALL_P1);
                 lese_RAM_Zelle;
                 ByteToString(RAM_Zelle);
                 b1:=111;
                 c1:=ByteToChar(b1);
                 Write_String:=c1+Write_String;
                 WriteLn;


     |

     BC_CONIN  : AE_WRITE_ADRESS(0,RAM_Z80_High,RAM_Z80CALL_P1);
                 schreibe_RAM_Zelle(ConsoleIn);
                 ConsoleIn:=0;

     |


   else
     SetBit(LED_ROT);
   endcase;



    // der Adress Extender gibt die Adressleitungen frei
    AE_WRITE_BYTE(ADRESS_TRISTATE);

    BC_Bus_freigeben;

    ClearBit(Z80AK_A);

    // warten bis Z80 fertig ist
    while BitLow(Z80CALL_E) do
    endwhile;
    
    SetBit(Z80AK_A);

    SetBit(LED_GRUEN);

  endif;


end Z80CALL_abfragen;









{--------------------------------------------------------------}
{ Main Program }
{$IDATA}







begin

ASM;

.equ UBRR0 = UBRR0L

ENDASM;

  // Grundeinstellung der Ports
  InitPorts;

  INIT_SER_PORT;

  ConsoleIn:=0;

  ClearBit(LED_GRUEN);  // LED_GRUEN aus
  ClearBit(LED_ROT);  // LED_ROT aus


  // Abschalten der WAIT-Logik
  ClearBit(BCWA_A);  // High aktiv
  SetBit(BCWCLR_A);  // Low aktiv


  wait_ms(10);

  COPY_ARRAY_TO_RAM;

  wait_ms(10);

  starte_Z80;

  wait_ms(10);

  sende_Zeichen(64);  // @

  loop

    RX_Puffer_abfragen;

    if Zeichen>0 then
      Steuer_String_lesen;
    endif;

    Z80CALL_abfragen;

  endloop;


end BC.


